﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace BabyShop.Site.Exts.Extensions
{
    internal static class ValueProviderExtensions
    {
        public static QueryValueResult GetQueryValue(this IValueProvider valueProvider, string name, Type type) {
            var valueProviderResult = valueProvider.GetValue(name);
            if (valueProviderResult == null || valueProviderResult.AttemptedValue.IsNullOrEmpty())
                return new QueryValueResult(null, null);

            var modelState = new ModelState { Value = valueProviderResult };

            object value = null;
            try {
                value = valueProviderResult.ConvertTo(type);
            }
            catch (Exception ex) {
                modelState.Errors.Add(ex);
            }
            return new QueryValueResult(value, modelState);
        }
    }
}