﻿using System.Data.Entity;
using System.Web.Mvc;
using System.Web.Routing;
using BabyShop.Site.Data;
using BabyShop.Site.Exts.ModelBinders;
using BabyShop.Site.Foundation;

namespace BabyShop.Site
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801

    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters) {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes) {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");

            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{keyGuid}", // URL with parameters
                new { controller = "Home", action = "Default", keyGuid = UrlParameter.Optional },
                new[] { "BabyShop.Site.Controllers" }
            );
        }

        protected void Application_Start() {
            //Database.SetInitializer(new AppServicesIntializer());

            AreaRegistration.RegisterAllAreas();

            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
            ModelBinders.Binders.DefaultBinder = new JqGridModelBinder();

            PersistentDataContainer.LoadCurrent = () => new SessionContainer();
        }
    }
}