﻿using System.Linq.Expressions;

namespace BabyShop.WebSite.Exts.Extensions
{
    internal static class ExpressionExtensions
    {
        public static Expression AndAlso(this Expression left, Expression right) {
            return Expression.AndAlso(left, right);
        }
        public static Expression OrElse(this Expression left, Expression right) {
            return Expression.OrElse(left, right);
        }
        public static Expression Call(this Expression instance, string methodName, params Expression[] arguments) {
            return Expression.Call(instance, instance.Type.GetMethod(methodName), arguments);
        }
        public static Expression Property(this Expression expression, string propertyName) {
            return Expression.Property(expression, propertyName);
        }
        public static Expression GreaterThan(this Expression left, Expression right) {
            return Expression.GreaterThan(left, right);
        }

        public static Expression Equal(this Expression left, Expression right) {
            return Expression.Equal(left, right);
        }

        public static Expression ToLambda(this Expression body, params  ParameterExpression[] parameters) {
            return Expression.Lambda(body, parameters);
        }
        public static Expression<TDelegate> ToLambda<TDelegate>(this Expression body, params  ParameterExpression[] parameters) {
            return Expression.Lambda<TDelegate>(body, parameters);
        }
    }
}